unit uperszahl;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  ExtCtrls, Buttons, Grids;

type

  { Tfperszahl }

  Tfperszahl = class(TForm)
    BitBtn1: TBitBtn;
    b_dateneinlesen: TButton;
    b_statistik: TButton;
    e_pkwzahl: TEdit;
    e_perssumme: TEdit;
    e_durchschnitt: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    lpersliste: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    lbdatei: TListBox;
    Memo1: TMemo;
    OpenDialog1: TOpenDialog;
    t_statistik: TStringGrid;
    procedure b_dateneinlesenClick(Sender: TObject);
    procedure b_statistikClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  fperszahl: Tfperszahl;
  perszahl : ARRAY[1..100] OF BYTE;
  pkwzahl : 1..100;



implementation

{$R *.lfm}

{ Tfperszahl }

procedure Tfperszahl.FormCreate(Sender: TObject);
VAR i,b : BYTE;
begin
  //Init
  pkwzahl := 1;
  FOR i:=1 TO 100 DO perszahl[i] := 0;

  //Tabellenstyle
  t_statistik.cells[0,0]:='Personenzahl';
  t_statistik.cells[0,1]:='PKW-Zahl';
  t_statistik.cells[0,2]:='PKW-Zahl in %';
  FOR b:= 1 TO 8 DO BEGIN
    t_statistik.ColWidths[b]:=32;
    t_statistik.cells[b,0]:=INTTOSTR(b);
  END;

end;


procedure Tfperszahl.b_statistikClick(Sender: TObject);
VAR perssumme,e,z,d,v,f,s,si,a,i,j : WORD;
    ds : SINGLE;
begin
 //Init
 e:=0;z:=0;d:=0;v:=0;f:=0;s:=0;si:=0;a:=0;perssumme:=0;

 //Gesamtzahl Personen
 FOR i := 1 TO pkwzahl DO perssumme:=perssumme + perszahl[i];


 //Statistik
 FOR i := 1 TO pkwzahl DO
  CASE perszahl[i] OF
   1 : e:=e+1;
   2 : z:=z+1;
   3 : d:=d+1;
   4 : v:=v+1;
   5 : f:=f+1;
   6 : s:=s+1;
   7 : si:=si+1;
   8 : a:=a+1;
  END;

 //Tabelle füllen
 t_statistik.cells[1,1]:=INTTOSTR(e);
 t_statistik.cells[2,1]:=INTTOSTR(z);
 t_statistik.cells[3,1]:=INTTOSTR(d);
 t_statistik.cells[4,1]:=INTTOSTR(v);
 t_statistik.cells[5,1]:=INTTOSTR(f);
 t_statistik.cells[6,1]:=INTTOSTR(s);
 t_statistik.cells[7,1]:=INTTOSTR(si);
 t_statistik.cells[8,1]:=INTTOSTR(a);

 //Berechnung Durchschnitt
 ds:=perssumme/pkwzahl;
 e_durchschnitt.text:=FLOATTOSTRF(ds,ffnumber,8,2);

 //weitere Ausgaben
 e_pkwzahl.text:=INTTOSTR(pkwzahl);
 e_perssumme.text:=INTTOSTR(perssumme);

 //Tabelle füllen mit den relativen Häufigkeiten
 t_statistik.cells[1,2]:=FLOATTOSTRF(e/pkwzahl,ffnumber,8,2);
 t_statistik.cells[2,2]:=FLOATTOSTRF(z/pkwzahl,ffnumber,8,2);
 t_statistik.cells[3,2]:=FLOATTOSTRF(d/pkwzahl,ffnumber,8,2);
 t_statistik.cells[4,2]:=FLOATTOSTRF(v/pkwzahl,ffnumber,8,2);
 t_statistik.cells[5,2]:=FLOATTOSTRF(f/pkwzahl,ffnumber,8,2);
 t_statistik.cells[6,2]:=FLOATTOSTRF(s/pkwzahl,ffnumber,8,2);
 t_statistik.cells[7,2]:=FLOATTOSTRF(si/pkwzahl,ffnumber,8,2);
 t_statistik.cells[8,2]:=FLOATTOSTRF(a/pkwzahl,ffnumber,8,2);

end;

procedure Tfperszahl.b_dateneinlesenClick(Sender: TObject);
VAR z : INTEGER;
begin
 IF opendialog1.execute THEN lbdatei.items.loadfromfile(opendialog1.filename);  // Wenn der Opendialog ausgeführt wird, dann lade Daten zeilenweise aus der augewählten Datei in die Listbox .
 pkwzahl:=lbdatei.Count;                                                       //zählt die Textzeilen = Anzahl der PKW
 FOR z:=1 TO pkwzahl DO perszahl[z]:=STRTOINT(lbdatei.items[z-1]);             //jede einzelne Textzeilen in der Listbox wird in das Datenfeld perszahl übertragen
end;

end.

